﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.IO;
using GroupLab.Networking;
using System.ComponentModel;
using MediaItemContract;

namespace PresenceItem
{
    public class Presence: AbstractPerson
    {
        public IPerson person { get; set; }
        //public string guid;
        public ImageSource iconSource {get; set; }
        public ImageSource thumbnailSource {get;set;}
        //public SharedDictionary sd;
        public Subscription imageSub;
        //public System.Windows.Controls.Image thumbnail;
        //public event EventHandler thumbnailSourceChanged;
        //public event PropertyChangedEventHandler PropertyChanged;

        public Presence(SharedDictionary sd, string path)
            : base(sd, path)
        {
            //this.guid = guid;
            iconSource = new BitmapImage(new Uri("images/laughing.jpg", UriKind.Relative));
            thumbnailSource = new BitmapImage(new Uri("images/laughing.jpg", UriKind.Relative));
            //this.sd = DataStore.sd;
            //this.sd[People.peoplePath + this.guid + "/image.unreliable"] = "true";
            /*this.imageSub = new Subscription();
            this.imageSub.BeginInit();
            this.imageSub.Dictionary = this.sd;
            this.imageSub.Pattern = path + "/image";
            this.imageSub.Notified += new SubscriptionEventHandler(imageSub_Notified);
            this.imageSub.EndInit();*/
        }

        /*public Presence(Person person)
            : this(person.sd, person.path)
        {

        }*/

        void imageSub_Notified(object sender, SubscriptionEventArgs e)
        {
            if(e.Value == null || e.Reason == SubscriptionNotification.AttributeChange)
            {
                return;
            }
            //MemoryStream stream = new MemoryStream(e.Value as byte[]);
            MemoryStream stream = e.Value as MemoryStream;
            stream.Seek(0, SeekOrigin.Begin);
            JpegBitmapDecoder decoder = new JpegBitmapDecoder(stream, BitmapCreateOptions.PreservePixelFormat, BitmapCacheOption.OnLoad);
            BitmapSource image = decoder.Frames[0];
            //iconSource = image;
            thumbnailSource = image;
            //thumbnailSourceChanged(this, EventArgs.Empty);
            /*if (PropertyChanged != null)
            {
                //Console.WriteLine("new frame");
                PropertyChanged(this, new PropertyChangedEventArgs("thumbnailSource"));
            }*/
            OnPropertyChanged("thumbnailSource");
            //stream.Seek(0, SeekOrigin.Begin);
            //this.thumbnail.Source = image;
            //Console.WriteLine("new frame");
        }

        /*public void UpdateImage(BitmapSource image)
        {
            MemoryStream stream = new MemoryStream();
            JpegBitmapEncoder encoder = new JpegBitmapEncoder();
            encoder.FlipVertical = true;
            encoder.QualityLevel = 30;
            encoder.Frames.Add(BitmapFrame.Create(image));
            encoder.Save(stream);
            //stream.Seek(0, SeekOrigin.Begin);
            //this.sd[People.peoplePath + this.guid + "/image"] = stream.ToArray();
            this.sd[this.path + "/image"] = stream;
            //this.sd[People.peoplePath + this.guid + "/image.unreliable"] = "true";
            //stream.Dispose();
        }

        public void LoadImage()
        {
            BitmapSource image = this.sd[path + "/image"] as BitmapSource;
            iconSource = image;
            thumbnailSource = image;
        }*/

        /*public void AddLocale(Locale locale)
        {
            this.sd[this.path + "/locales#-0"] = locale.guid;
        }*/

        /*public override void Initialize()
        {
            
        }*/
    }
}
