﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using GroupLab.Networking;
using System.Collections;

namespace UIDemo
{
    public class Artifacts
    {
        SharedDictionary sd;
        SystemWindow sw;
        string guid;
        //Subscription artifactSub;
        public static string artifactsPath = "/artifacts/";
        public string myArtifactsPath;
        ArrayList artifactList;

        public Artifacts(SharedDictionary sd, SystemWindow sw, string guid)
        {
            this.sd = sd;
            this.sw = sw;
            this.guid = guid;
            //myArtifactsPath = People.peoplePath + guid + "/artifacts";
            myArtifactsPath = People.peoplePath + guid + "/artifacts/";
            artifactList = new ArrayList();
            //this.artifactSub = new Subscription();
            //this.artifactSub.BeginInit();
            //artifactSub.Dictionary = this.sd;
            //artifactSub.Pattern = artifactsPath + "?";
            //artifactSub.Notified += new SubscriptionEventHandler(peopleSub_Notified);
            //artifactSub.EndInit();
        }

        public Artifact AddNewArtifact(Artifact artifact)
        {
            Map map = new Map();
            //string guid = System.Guid.NewGuid().ToString();
            map["guid"] = artifact.guid;
            map["item"] = artifact.plugin.Identifier;
            this.sd[artifactsPath + artifact.guid] = map;
            //this.sd[myArtifactsPath + "#-0"] = item;
            //this.sd[myArtifactsPath + artifact.guid] = artifact.guid;
            this.sd[myArtifactsPath + artifact.guid] = map;
            //Artifact artifact = new Artifact(guid);
            //artifact.guid = guid;
            //artifact.Initialize();
            artifactList.Add(artifact);
            return artifact;
        }

        /*public Artifact FromGuid(string guid)
        {
            //Console.WriteLine("From Guid " + artifactsPath + guid + "/url");
            //string url = DataStore.sd[artifactsPath + guid + "/url"] as string;
            //WebPage webPage = new WebPage(guid);
            //webPage.Initialize();
            //return webPage;
            Artifact artifact = new Artifact(guid);
            return artifact;
        }*/

        public Artifact CreateArtifact(Plugin plugin)
        {
            string guid = System.Guid.NewGuid().ToString();
            Artifact artifact = new Artifact(guid, plugin);
            artifactList.Add(artifact);
            return artifact;
        }
    }
}
