﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using GroupLab.Networking;
using System.Windows;

namespace UIDemo
{
    public static class DataStore
    {
        public static SharedDictionary sd;
        //public static string sdURL;
        //public static Person account;
        //public static SystemWindow systemWindow;

        /*public DataStore()
        {
            SetupSharedDictionary("tcp://localhost:test");
        }*/

        public static void SetupSharedDictionary(string url)
        {
            if (System.Windows.Forms.DialogResult.OK == GroupLab.Networking.UrlPrompt.Show(ref url))
            {
                // add your code here
                // it might look something like this
                sd = new SharedDictionary();
                sd.Url = url;
                //Console.WriteLine("SD URL is " + sd.Url);
                //sd.Connected += new EventHandler(sd_Connected);
                //sd.Opened += new EventHandler(sd_Opened);
                //sd.Closed += new EventHandler(sd_Closed);
                //sd.Disconnected += new DisconnectedEventHandler(sd_Disconnected);
                //sd.Open(true);
            }
            else
            {
                Application.Current.Shutdown();
            }
        }

        public static string CreateAccount()
        {
            Map account = new Map();
            string guid = System.Guid.NewGuid().ToString();
            account["guid"] = guid;
            //Account.singleton.guid = guid;
            sd[People.peoplePath + guid] = account;
            GroupLab.Networking.SharedDictionary.Vector artifacts = new SharedDictionary.Vector();
            sd[People.peoplePath + guid + "/artifacts"] = artifacts;
            //Map contacts = new Map();
            GroupLab.Networking.SharedDictionary.Vector contacts = new SharedDictionary.Vector();
            sd[People.peoplePath + guid + "/contacts"] = contacts;
            return guid;
        }
        /*void sd_Disconnected(object sender, DisconnectedEventArgs e)
        {
            Console.WriteLine("Disconnected");
        }

        void sd_Closed(object sender, EventArgs e)
        {
            Console.WriteLine("Closed");
        }

        void sd_Opened(object sender, EventArgs e)
        {
            Console.WriteLine("Opened");
            //account = new Person(People.CreateAccount());
            //systemWindow.PopulatePeopleThumbnailWrap();
        }

        void sd_Connected(object sender, EventArgs e)
        {
            Console.WriteLine("Connected");
        }*/
    }
}
