﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using GroupLab.Networking;
using MediaItemContract;

namespace UIDemo
{
    public abstract class LocaleMember: Notifier
    {
        public Plugin plugin { get; set; }
        public string guid { get; set; }
        protected SharedDictionary sd;

        public LocaleMember(SharedDictionary sd, string guid, Plugin plugin)
        {
            this.sd = sd;
            this.guid = guid;
            this.plugin = plugin;
        }

        public LocaleMember(string guid, Plugin plugin) : this(DataStore.sd, guid, plugin)
        {
            //this.sd = DataStore.sd;
            //this.guid = guid;
        }

        public abstract MediaItem createMediaItem();

        public abstract IItem createPluginItem();

        /*public MediaItem createMediaItem()
        {
            IItem item = plugin.CreatePlugin();
            MediaItem mediaItem = new MediaItem(item, this);
            return mediaItem;
        }*/
    }
}
