﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections;

namespace UIDemo
{
    /// <summary>
    /// Interaction logic for LocaleTileItem.xaml
    /// </summary>
    public partial class LocaleTileItem : UserControl, LocaleContainer
    {
        //Person previewPerson;
        public LocaleTileItem(Locale locale)
        {
            InitializeComponent();
            this.locale = locale;
            this.DataContext = this.locale;
            this.ShowIndicator = false;
        }

        public void UpdateTile()
        {
            /*this.preview.Children.Clear();
            IEnumerator enunmerator = this.locale.peopleList.Values.GetEnumerator();
            enunmerator.Reset();
            enunmerator.MoveNext();
            Person firstPerson = enunmerator.Current as Person;
            this.preview.Children.Add(firstPerson.createMediaItem());*/
            /*IEnumerator enunmerator = this.locale.artifactList.Values.GetEnumerator();
            enunmerator.Reset();
            Artifact firstArtifact = enunmerator.Current as Artifact;
            this.preview.Children.Add(firstArtifact.createMediaItem());*/
            this.locale.UpdatePreviewPerson();
        }

        /*public Person PreviousPerson
        {
            get { return previewPerson; }
            set
            {
                previewPerson = value;
            }
        }*/

        public bool ShowIndicator
        {
            get
            {
                return this.indicator1.BorderBrush == Brushes.Black;
            }
            set
            {
                if (value == true)
                {
                    this.indicator1.BorderBrush = Brushes.Black;
                }
                else
                {
                    this.indicator1.BorderBrush = Brushes.Transparent;
                }
            }
        }

        public Widget CreateWidget()
        {
            Widget widget = new Widget();
            locale.widget = widget;
            widget.locale = locale;
            locale.PopulateWidget(widget);
            widget.InitialSize();
            //widget.ShrinkToIcon();
            return widget;
        }

        #region LocaleContainer Members

        public Locale locale
        {
            get;
            set;
        }

        #endregion
    }
}
