﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections;
using System.Windows;

namespace UIDemo
{
    class WindowComparer:IComparer
    {

        #region IComparer Members

        public int Compare(object x, object y)
        {
            Window windowX = x as Window;
            Window windowY = y as Window;
            double diff = windowX.Left - windowY.Left;
            if (diff == 0)
            {
                return 0;
            }
            else if (diff < 0)
            {
                return -1;
            }
            else
            {
                return 1;
            }
        }

        #endregion
    }
}
