﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Drawing;
using System.Diagnostics;

namespace WebItem
{
    /// <summary>
    /// Interaction logic for WebBrowserItem.xaml
    /// </summary>
    public partial class WebBrowserItem : UserControl
    {
        WebPage webPage;
        //WebBrowserOverlayWF wbo;
        WebBrowserOverlay wbo;
        System.Windows.Forms.WebBrowser wb;
        System.Windows.Forms.Form wbForm;
        Window _owner;
        //System.Windows.Forms.WebBrowser wb2;
        //String url;
        //Bitmap thumbnail;
        public bool loadedInThisContainer;
        //public delegate void LocationChangedEvent();
        //public LocationChangedEvent LocationChanged; 
        public delegate void UpdateURLDelegate();
        public WebBrowserItem(WebPage webPage)
        {
            InitializeComponent();
            this.webPage = webPage;
            wb = new System.Windows.Forms.WebBrowser();
            wbForm = new System.Windows.Forms.Form();
            wb.Dock = System.Windows.Forms.DockStyle.Fill;
            wbForm.Controls.Add(wb);
            //wbo = new WebBrowserOverlayWF(_webBrowserPlacementTarget);
            //wb = wbo.WebBrowser;

            //wb.Navigate(new Uri("http://www.ucalgary.com"));
            loadedInThisContainer = false;
            //Console.WriteLine("Add newURL in browser");
            webPage.newURL += new EventHandler(webPage_newURL);
            wb.Navigated += new System.Windows.Forms.WebBrowserNavigatedEventHandler(wb_Navigated);
            //wbo.WebBrowser.Navigated += new System.Windows.Forms.WebBrowserNavigatedEventHandler(wb_Navigated);
        }

        void wb_Navigated(object sender, System.Windows.Forms.WebBrowserNavigatedEventArgs e)
        {
            Console.WriteLine("are we here");
            webPage.Navigate(wb.Url.ToString());
        }

        void webPage_newURL(object sender, EventArgs e)
        {
            //Console.WriteLine("Browser new URL");
            UpdateURLDelegate updateURLDelegate = delegate {
                UpdateURL();};
            Dispatcher.Invoke(updateURLDelegate);
            /*if (wb.Url.ToString() != webPage.url)
            {
                wb.Navigate(new Uri(webPage.url));
            }*/
        }

        public void UpdateURL()
        {
            /*if (wb.Url != null && wb.Url.ToString() != webPage.url)
            {
                wb.Navigate(new Uri(webPage.url));
            }*/
            if (wbo != null && wbo.WebBrowser.Url != null && wbo.WebBrowser.Url.ToString() != webPage.url)
            {
                wbo.WebBrowser.Navigate(new Uri(webPage.url));
            }
        }

        private void UserControl_Loaded(object sender, RoutedEventArgs e)
        {
            /*if (loadedInThisContainer)
            {
                return;
            }*/
            Console.WriteLine("UserControl_Loaded");
            Window owner = Window.GetWindow(this);
            Debug.Assert(owner != null);
            /*if (_owner == owner && loadedInThisContainer)
            {
                return;
            }*/

            _owner = owner;
            //wbo = new WebBrowserOverlayWF(_webBrowserPlacementTarget,wb);
            //wbo.Load(owner);
            wbo = new WebBrowserOverlay(_webBrowserPlacementTarget, wb, wbForm);
            //wb = wbo.WebBrowser;
            //wbo.WebBrowser.Navigated += new System.Windows.Forms.WebBrowserNavigatedEventHandler(wb_Navigated);
            if (webPage.url != null)
            {
                wb.Navigate(new Uri(webPage.url));
            }

            
            
            //wbo.FirstShow(owner);
            /*wbo = new WebBrowserOverlayWF(_webBrowserPlacementTarget, owner, 0.7);
            wb = wbo.WebBrowser;

            wb.Navigate(new Uri("http://www.ucalgary.com"));*/

            loadedInThisContainer = true;
        }

        private void UserControl_IsVisibleChanged(object sender, DependencyPropertyChangedEventArgs e)
        {
            Console.WriteLine("UserControl_IsVisibleChanged");
            /*if (_owner == null)
            {
                Console.WriteLine("hoho");
                return;
            }*/
            /*if (!loadedInThisContainer)
            {
                Console.WriteLine("hoho");
                return;
            }*/
            if (loadedInThisContainer) //(wbo.IsSetInContainer)
            {
                Console.WriteLine("Loaded");
                /*if (wbo.IsVisible)
                {
                    wbo.Hide();
                }
                else
                {
                    wbo.Show();
                }*/
                _owner = null;
                wbo.UnLoad();
                loadedInThisContainer = false;
            }
            else
            {
                Console.WriteLine("Not loaded");
                //return;
            }
            /*if (wbo != null && wbo.IsVisible)
            {
                Console.WriteLine("Hide");
                Window owner = Window.GetWindow(this);
                if (owner == null)
                {
                    Console.WriteLine("actually Hide");
                    wbo.Hide();
                }
            }
            else if (wbo != null && !wbo.IsVisible)
            {
                Console.WriteLine("Show");
                Window owner = Window.GetWindow(this);
                Debug.Assert(owner != null);
                Debug.Assert(_owner != null);
                if (_owner == owner)
                {
                    Console.WriteLine("Actually Show");
                    wbo.Show();
                }
            }*/
            Console.WriteLine("aha");
        }

        /*public void DetachFromContainer()
        {
            Console.WriteLine("DetackFromContainer");
            if (!loadedInThisContainer && _owner == null)
            {
                return;
            }
            _owner = null;
            //wbo.DetachFromContainer();
            wbo.UnLoad();
            loadedInThisContainer = false;
        }

        public void AttachToContainer()
        {
            Window owner = Window.GetWindow(this);
            Debug.Assert(owner != null);
            if (loadedInThisContainer && _owner == owner)
            {
                return;
            }
            _owner = owner;
            Console.WriteLine("AttachToContainer");
            //wbo.AttachToContainer(owner);
            wbo.Load(owner);
            wb.Navigate(new Uri(webPage.url));
            loadedInThisContainer = true;
        }

        public void Reposition()
        {
            wbo.Reposition();
        }

        public void RemoveOverlay()
        {

        }*/
    }
}
