﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Media;
using System.ComponentModel;

namespace MediaItemContract
{
    public interface IPerson : INotifyPropertyChanged
    {
        string FirstName { get; set; }
        string LastName { get; set; }
        string DisplayName { get; set; }
        string PersonGuid { get; set; }
        bool IsOnline { get; set; }
        string Email { get; set; }
        string IPAddress { get; set; }
        string SDGuid { get; set; }
        ImageSource StaticIcon { get; set; }
        ImageSource StaticThumbnail { get; set; }
        ImageSource LiveImage { get; set; }
    }
}
